﻿/*
 * Golden Fleece 1.0 by Durn
 * This addon collects gold coins dropped by Golden Fleece http://www.wowhead.com/item=86585/golden-fleece
 * I've adapted this plugin from code by LiquidAtoR and Hazard (thank you to them).
 */

namespace RepCollector
{
    using Styx;
    using Styx.Common;
    using Styx.Common.Helpers;
	using Styx.CommonBot;
    using Styx.CommonBot.Frames;
    using Styx.CommonBot.Inventory;
    using Styx.CommonBot.Profiles;
    using Styx.Helpers;
    using Styx.Pathing;
    using Styx.Plugins;
    using Styx.WoWInternals;
	using Styx.WoWInternals.Misc;
	using Styx.WoWInternals.World;
    using Styx.WoWInternals.WoWObjects;

    using System;
    using System.Collections.Generic;
	using System.ComponentModel;
	using System.Data;
    using System.Diagnostics;
    using System.Drawing;
    using System.IO;
    using System.Linq;
	using System.Reflection;
    using System.Runtime.InteropServices;
    using System.Text;
    using System.Threading;
    using System.Windows.Forms;
    using System.Windows.Media;
    using System.Xml.Linq;
	
    public class RepCollector : HBPlugin
    {
        public override string Name { get { return "Golden Fleece"; } }
        public override string Author { get { return "Durn"; } }
        public override Version Version { get { return new Version(1,0); } }

        public override void Pulse()
        {
            Thread.Sleep(1 / 30);
            try
            {
                if (!StyxWoW.Me.Combat || !StyxWoW.Me.IsDead)
					PickUpGold();
            }
            catch (ThreadAbortException)
            {
            }
        }

        public static void MoveToLocation(WoWPoint loc)
        {
            while (loc.Distance(StyxWoW.Me.Location) > 5)
            {
                Navigator.MoveTo(loc);
            }
        }

        static public void PickUpGold()
        {
            ObjectManager.Update();
            List<WoWGameObject> objList = ObjectManager.GetObjectsOfType<WoWGameObject>()
                .Where(gold => (gold.Distance2D <= 80 && (gold.Entry == 186633 || gold.Entry == 186634 || gold.Entry == 210894 || gold.Entry == 214458 || gold.Entry == 214985))).OrderBy(gold => gold.Distance).ToList();
            foreach (WoWGameObject gold in objList)
            {
                if (!gold.InLineOfSight) return;
                if (StyxWoW.Me.Combat) return;
                MoveToLocation(WoWMovement.CalculatePointFrom(gold.Location, -3));
                Thread.Sleep(1000);
                gold.Interact();
                Thread.Sleep(2000);
                Logging.Write(LogLevel.Normal, Colors.DarkRed, "[Golden Fleece Coins]: {0} collected", gold.Name);
            }
        }
    }
}